VBR_BASE:	equ	$7ffee
MEMORY:		equ	$7fff8
DELAY:		equ	$7ffd8

		IFEQ	EXE
		move.l	#0,VBR_base
		move.l	#BASEF,MEMORY
		move	#$1400,DELAY
		ENDC

raster: macro
	movem.l	d0-a6,rej+4
	move.l	#.r\@,rej
	rts
.r\@:	movem.l	rej+4,d0-a6
	endm

jump:	macro
	move.l	#.p\@,jumpadr
	bra	\1
.p\@:
	endm
return:	macro
	move.l	jumpadr(pc),a1
	jmp	(a1)
	endm

wait:	macro
	move	#\1,d0
.w\@:	movem.l	d0-a6,rej+4
	move.l	#.t\@,rej
	rts
.t\@:	movem.l	rej+4,d0-a6
	dbf	d0,.w\@
	endm

NewLev3:	movem.l d0-a6,-(sp)
		bsr	mt_music
		move.l	rej,a1
		jsr	(a1)
		movem.l	(sp)+,d0-a6
		move	#$20,$dff09c
		rte


p_setcolors:	move	#0,d0
p_SetC:		lea	(a3),a1			;copper
		lea	(a4),a2			;color tab
		move	d4,d5			;color nr. - 1
p_SC1:		move	(a2)+,d1
		move	d1,d2
		andi	#$f,d2
		mulu	d0,d2
		lsr	#4,d2
		move	d1,d3
		andi	#$f0,d3
		mulu	d0,d3
		lsr	#4,d3
		andi	#$f0,d3
		andi	#$f00,d1
		mulu	d0,d1
		lsr	#4,d1
		andi	#$f00,d1
		or	d3,d1
		or	d2,d1
		move	d1,2(a1)
		lea	4(a1),a1
		dbf	d5,p_SC1
		raster
		raster
		addq	#1,d0
		cmpi	#17,d0
		bne.s	p_SetC
		RETURN
;		rts

;a3 - copperlist, d4 - nr.of colors

l_fadecolors:	move	#16,d0
l_fadcol:	lea	(a3),a1
		move	d4,d3			;no. of colors - 1
l_fad1:		move	2(a1),d1
		andi	#$f,d1
		beq.s	l_fad2
		subi	#1,2(a1)
l_fad2:		move	2(a1),d1
		andi	#$f0,d1
		beq.s	l_fad3
		subi	#$10,2(a1)
l_fad3:		move	2(a1),d1
		andi	#$f00,d1
		beq.s	l_fad4
		subi	#$100,2(a1)
l_fad4:		addi.l	#4,a1
		dbf	d3,l_fad1
		raster
		raster
		dbf	d0,l_fadcol
		RETURN
;		rts


l_copper2:
dc.w	$180,0,$182,0,$184,0,$186,0,$188,0
dc.w	$18A,0,$18C,0,$18E,0,$190,0,$192,0
dc.w	$194,0,$196,0,$198,0,$19A,0,$19C,0
dc.w	$19E,0,$1A0,0,$1A2,0,$1A4,0,$1A6,0
dc.w	$1A8,0,$1AA,0,$1AC,0,$1AE,0,$1B0,0
dc.w	$1B2,0,$1B4,0,$1B6,0,$1B8,0,$1BA,0,$1BC,0,$1be,0

dc.w	$108,0,$10a,0
dc.l	$920038,$9400d0
dc.l	$8e3881,$90ffc3
dc.l	$1020000,$1040000
dc.w	$1fc,0,$106,0,$10c,0
l_scr3:
dc.w	$e0,l_arrakis/$10000,$e2,l_arrakis&$ffff
dc.w	$e4,[l_arrakis+11600]/$10000,$e6,[l_arrakis+11600]&$ffff
dc.w	$e8,[l_arrakis+2*8000]/$10000,$ea,[l_arrakis+2*8000]&$ffff
dc.w	$ec,[l_arrakis+3*8000]/$10000,$ee,[l_arrakis+3*8000]&$ffff
dc.w	$f0,[l_my+4*8000]/$10000,$f2,[l_my+4*8000]&$ffff

l_up:
dc.l	$5001ff00
l_bpl:
dc.l	$0100a300
l_dn:
dc.l	$e101ff00,$01000300
dc.l	-2
