;------------------------------------------------------------------------
;Pierwiastkowanie - by Kane of Suspect, 22.12.1994
;-------------------------------------------------
;VALUE RANGE:  0 - $7fffffff (0 - 2147483647)  !!!
;Input:  d0 - value, Output: d0 - square root of value

sq_SQRT:	movem.l	d1-d6,-(sp)
		rol.l	#8,d0
		moveq	#$f,d1
sq_1:		cmp.b	sq_tab1(pc,d1.w),d0	;a*a
		beq.s	sq_2
		dbhi	d1,sq_1
sq_2:		sub.b	sq_tab1(pc,d1.w),d0

		lsl	#4,d1			;a
		move	d1,d2
		add	d2,d2			;a*2 *16
		rol.l	#8,d0
		
		moveq	#0,d4
		moveq	#0,d3
sq_3:		addq	#1,d3
		move	d4,d5
		move	d2,d4
		add	d3,d4
		mulu	d3,d4			;ab * b
		cmp	d4,d0
		bpl.s	sq_3
		sub	d5,d0
		subq	#1,d3
		add	d3,d1			;a,b

		rol.l	#8,d0			;3-rd figure
		move.l	d0,d6
		andi.l	#$ffffff,d6
		lsl	#4,d1
		move	d1,d2
		add	d2,d2

		moveq	#0,d4
		moveq	#0,d3
sq_4:		addq	#1,d3
		move.l	d4,d5
		move	d2,d4
		add	d3,d4
		mulu	d3,d4
		cmp.l	d4,d6
		bpl.s	sq_4
		sub.l	d5,d0
		subq	#1,d3
		add	d3,d1			;a,b,c

		rol.l	#8,d0			;4-th figure
		lsl	#4,d1
		move	d1,d2
		add	d2,d2

		moveq	#0,d3
sq_5:		addq	#1,d3
		move	d2,d4
		add	d3,d4
		mulu	d3,d4
		cmp.l	d4,d0
		bpl.s	sq_5
		subq	#1,d3
		add	d3,d1			;a,b,c,d
		move.l	d1,d0
		movem.l	(sp)+,d1-d6
		rts

sq_tab1:	dc.b	0,1,4,9,16,25,36,49,64,81,100,121,144,169,196,225

